-- Metadata hack to update tables (Use only if already have previous Meatahack installed)
-- --------------------------------------

--
-- Add columns for title, meta description and keywords
-- for product
--
ALTER TABLE `jos_vm_product`
    ADD COLUMN `product_abstract` text,
    ADD COLUMN `product_canonical` text;


--
-- Add columns for title, meta description and keywords
-- for categories
--

ALTER TABLE `jos_vm_category` 
  ADD COLUMN `category_abstract` text,
  ADD COLUMN `category_canonical` text;


--
-- Add columns global metadata settings
-- for products
--
ALTER TABLE `jos_vm_product_metakeys` (
  ADD COLUMN `add_abstract` char(1) NULL default 'N',
  ADD COLUMN `generator` text,
  ADD COLUMN `subject` char(1) NULL default 'N',
  ADD COLUMN `classification` text,
  ADD COLUMN `author` text,
  ADD COLUMN `organization` text,
  ADD COLUMN `copyright` text,
  ADD COLUMN `country` text,
  ADD COLUMN `content_language` text,
  ADD COLUMN `language` text,
  ADD COLUMN `designer` text,
  ADD COLUMN `comments` text,
  ADD COLUMN `no_email_collection` char(1) NULL default 'N';


--
-- Add columns for global metadata settings
-- for categories
--
ALTER TABLE `jos_vm_category_metakeys` (
  ADD COLUMN `add_abstract` char(1) NULL default 'N',
  ADD COLUMN `generator` text,
  ADD COLUMN `subject` char(1) NULL default 'N',
  ADD COLUMN `classification` text,
  ADD COLUMN `author` text,
  ADD COLUMN `organization` text,
  ADD COLUMN `copyright` text,
  ADD COLUMN `country` text,
  ADD COLUMN `content_language` text,
  ADD COLUMN `language` text,
  ADD COLUMN `designer` text,
  ADD COLUMN `comments` text,
  ADD COLUMN `no_email_collection` char(1) NULL default 'N';
